︠931cb8a6-42b0-43e2-8083-39c9fc01a488a︠
%auto
# make sure to evaluate this cell to load the functions
URL='http://sage.math.washington.edu/home/jason/sage-field-plots/'
files=['lic_internal.pyx', 'plotfields.py','streamline.py']
for f in files:
    load(URL+f)
︡2a9d2138-d464-4f38-b0d1-5ca9d316350d︡{"stdout": "Compiling /home/sagenbws/.sage//temp/mod.math.washington.edu/549//tmp_0.pyx..."}︡
︠424078ae-2d4f-47fc-a504-600b364ae3f3︠
var('y')
F=[-1 - x^2 + y, 1 + x - y^2]
v=plot_vector_field(F,(x,-3,3),(y,-3,3),aspect_ratio=1)
v
︡2606d10c-c0a4-4929-96aa-1ee202a607e6︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
︠19e0f9cd-9317-40a7-97e5-31e7d80c9287︠
q=plot_streamlines(F, (x,-3,3), (y,-3,3))
q
︡8bc3e4f1-b5e1-43bb-af74-ea5406857e40︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
︠7c0d44a9-f3a7-43c1-b18f-1aa8e598e7c1︠
p=plot_field_texture(F, (x,-3,3), (y,-3,3),plot_points=400,alpha=0.9)
p
︡408f141f-12d0-4099-bc50-96192a70d195︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
︠75e99f37-3c82-480d-8e28-c03d9371bced︠
p+q
︡154deef8-befc-4566-bf69-3bab58e1c0d6︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
︠2d295ccf-645f-49f1-878a-ff293ee7f382a︠
%auto
# make sure to evaluate this cell to load the functions
    
# based on code from oddrobot, http://sagenb.org/home/pub/1532/
from sage.calculus.desolvers import desolve_system_rk4
x,y,t=var('x y t')
class DESolution:
    def __init__(self,system,time_range,initial,stepsize=0.05):
        
        self.tvar=time_range[0]
        self._times=srange(time_range[1],time_range[2],stepsize)
        self.vars=[v for v,_ in initial]
        self.dim=len(self.vars)
        self._soln=desolve_odeint(system, ics=[v for _,v in initial], times=self._times, dvars=self.vars, ivar=self.tvar)
        
    def phase_plot(self,vars=None,color='blue',**kwargs):
        # find which indices the specified variables are
        if vars is not None:
            vars_index=[self.vars.index(v) for v in vars]
        elif self.dim<=3:
            vars_index=range(self.dim)
        else:
            vars_index=range(2)
            
        p=line(self._soln[:,vars_index],color=color,**kwargs)
        # add an arrow head showing which way we are going around the phase line
        half=int(self._soln.shape[0]/2)
        p+=arrow(self._soln[half,vars_index], self._soln[half+1,vars_index],color=color)
        if len(vars_index)==2:
            p.axes_labels([str(self.vars[v]) for v in vars_index])
        return p
        
    def coordinates(self,colors=None,**kwargs):
        if colors is None:
            colors=rainbow(len(self.vars))
        p=Graphics()
        p+=sum(line(zip(self._times,self._soln[:,i]), color=colors[i], legend_label=str(self.vars[i]),**kwargs) for i in range(self.dim))
        return p
︡bfbe51f6-13fc-4f6e-bbde-b5cf0e4f5baf︡︡
︠1426d04c-c2dd-48be-a112-9dc3c86e6b3b︠
var('x,y')
F=[x-y^2,x-y]
solution=DESolution(F,[t,0,4],[(x,1),(y,0.5)])
solution.coordinates(['red','blue'])
︡6694a8f2-0e7e-48f0-8ad6-cbdd868c0669︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
︠fe7251b1-5daf-40a7-a0e5-ce15c45d5ec7︠
solution.phase_plot([x,y])
︡2e74a613-c5a1-4858-89be-2305d4609c74︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
︠ac9758df-fbfc-469d-9e1a-ecc9e69376d4︠
plot_streamlines(F,(x,0,2),(y,0,2))+solution.phase_plot([x,y],thickness=3)
︡be325544-0924-4525-9da0-5efbefab5757︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
︠fc23b972-8589-4ef6-8444-d4eb048e1cb7︠
plot_field_texture(F,(x,0,2),(y,0,2),alpha=0.8)+solution.phase_plot([x,y],thickness=3)
︡ec481aed-bc0b-4a91-a396-82870ed537d6︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
